filename=$1

# 操作前备份一下源文件
bak_filename=${filename}.bak
cp ${filename} ${bak_filename}

# 获取起始行集合
beginlines=$(grep -n 'Package: linux-headers-*' ${filename} | cut -d : -f 1)
endlines=$(grep -n 'Build-Profiles:' ${filename} | cut -d : -f 1)


# 获取起始行对
begin_end_arr=()
for i in ${beginlines[*]}; do
    for j in ${endlines[*]}; do
        if [ $j -gt $i ]; then
            # 在结尾行集合中找到首个大于起始行号的行,并认定为对应结尾行号,一起加入到结果对中
            begin_end_arr[${#begin_end_arr[*]}]=$i
            begin_end_arr[${#begin_end_arr[*]}]=$j
            echo begin_end_arr
            break;
        fi
    done
done

# 倒序遍历删除不匹配的行,一次遍历一对
#${#array[@]}获取数组长度用于循环
arr_length=${#begin_end_arr[@]}
# 删除最后一行的下一行到文件文件尾部
lastline_num=${begin_end_arr[$((${arr_length}-1))]}
sed -i $((${lastline_num}+1))',$d' ${filename}

# 剔除出首尾行,中间按对删除
for ((i=$((${arr_length}-2));i>=1;i=i-2))
do
    begin=$((${begin_end_arr[i-1]}+1))
    end=$((${begin_end_arr[i]}-1))
    sed -i ${begin}','${end}'d' ${filename}
done


# 删除首行之前的全部行
firstline_num=${begin_end_arr[0]} 
[[ ${firstline_num} -gt 1 ]] && sed -i '1,'$((${firstline_num}-1))'d' ${filename}

echo "done."
